package gov.fnal.vox.saz.bl;

import org.hibernate.Session;
import org.hibernate.SessionFactory;
import org.hibernate.cfg.Configuration;
import org.hibernate.service.ServiceRegistry;
import org.hibernate.service.ServiceRegistryBuilder;

public class HibernateUtil{
	private static final SessionFactory sessionFactory;
	private static final ServiceRegistry serviceRegistry;
	static{
		try{
			// Create the SessionFactory from hibernate.cfg.xml
			// Default location of hibernate.cfg.xml is base of classpath
			//With hibernate 4, old sessionFactory creation has been deprecated. Usign new onw
			//sessionFactory = new Configuration().configure().buildSessionFactory();
			Configuration configuration = new Configuration().configure();
			serviceRegistry = new ServiceRegistryBuilder().applySettings(configuration.getProperties()).buildServiceRegistry();
			sessionFactory = configuration.buildSessionFactory(serviceRegistry);
		}catch(Throwable ex){
			System.err.println("Initial SessionFactory creation failed." + ex);
			throw new ExceptionInInitializerError(ex);
		}
	}
	public static SessionFactory getSessionFactory(){
		return sessionFactory;
	}
	public static Session getSession(){
		return sessionFactory.getCurrentSession();
	}
	public static Session getNewSession(){
		return sessionFactory.openSession();
	}
}
