/*****************************************************************************
*       File            AdminDao.java
*       Author          Neha Sharma
*       Date            August 26' 2009
*       Organization    Fermi National Accelerator Laboratory
*       Description     The DAO interface for Admin entity.
*       Email           neha@fnal.gov
******************************************************************************/
package gov.fnal.vox.saz.dao;

import java.util.List;
import org.hibernate.Session;
import gov.fnal.vox.saz.entity.Admin;
import gov.fnal.vox.saz.exception.AddAdminException;
import gov.fnal.vox.saz.exception.BanAdminException;
import gov.fnal.vox.saz.exception.UnbanAdminException;
import gov.fnal.vox.saz.exception.FindAdminException;
import gov.fnal.vox.saz.exception.FindAdminUnexpectedException;
import gov.fnal.vox.saz.exception.ListAdminsException;

public interface AdminDao extends BaseDao{
	public void add(Session session,String dn,String enabled,String principal) throws AddAdminException;
	public Admin find(Session session,String dn) throws FindAdminException, FindAdminUnexpectedException;
	public List<Admin> list(Session session) throws ListAdminsException;
	public List<Admin> listAllBannedAdmins(Session session) throws ListAdminsException;
	public List<Admin> listAllUnbannedAdmins(Session session) throws ListAdminsException;
	public void banAdminBasedOnDN(Session session,String dn) throws BanAdminException;
	public void unbanAdminBasedOnDN(Session session,String dn) throws UnbanAdminException;
}

