/*****************************************************************************
*       File            CADao.java
*       Author          Neha Sharma
*       Date            August 26' 2009
*       Organization    Fermi National Accelerator Laboratory
*       Description     The DAO interface for CA entity.
*       Email           neha@fnal.gov
******************************************************************************/
package gov.fnal.vox.saz.dao;

import java.util.List;
import org.hibernate.Session;
import gov.fnal.vox.saz.entity.CA;
import gov.fnal.vox.saz.exception.AddCAException;
import gov.fnal.vox.saz.exception.BanCAException;
import gov.fnal.vox.saz.exception.UnbanCAException;
import gov.fnal.vox.saz.exception.TrustCAException;
import gov.fnal.vox.saz.exception.DistrustCAException;
import gov.fnal.vox.saz.exception.FindCAException;
import gov.fnal.vox.saz.exception.FindCAUnexpectedException;
import gov.fnal.vox.saz.exception.ListCAsException;

public interface CADao extends BaseDao{
	public void add(Session session,String dn,String enabled,String trusted) throws AddCAException;
	public CA find(Session session,String dn) throws FindCAException, FindCAUnexpectedException;
	public List<CA> list(Session session) throws ListCAsException;
	public List<CA> listAllBannedCAs(Session session) throws ListCAsException;
	public List<CA> listAllUnbannedCAs(Session session) throws ListCAsException;
	public List<CA> listAllTrustedCAs(Session session) throws ListCAsException;
	public List<CA> listAllDistrustedCAs(Session session) throws ListCAsException;
	public void banCABasedOnDN(Session session,String dn) throws BanCAException;
	public void unbanCABasedOnDN(Session session,String dn) throws UnbanCAException;
	public void trustCABasedOnDN(Session session,String dn) throws TrustCAException;
	public void distrustCABasedOnDN(Session session,String dn) throws DistrustCAException;
}

