/*****************************************************************************
*       File            RoleDao.java
*       Author          Neha Sharma
*       Date            August 26' 2009
*       Organization    Fermi National Accelerator Laboratory
*       Description     The DAO interface for Role entity.
*       Email           neha@fnal.gov
******************************************************************************/
package gov.fnal.vox.saz.dao;

import java.util.List;
import org.hibernate.Session;
import gov.fnal.vox.saz.entity.Role;
import gov.fnal.vox.saz.exception.AddRoleException;
import gov.fnal.vox.saz.exception.BanRoleException;
import gov.fnal.vox.saz.exception.UnbanRoleException;
import gov.fnal.vox.saz.exception.TrustRoleException;
import gov.fnal.vox.saz.exception.DistrustRoleException;
import gov.fnal.vox.saz.exception.FindRoleException;
import gov.fnal.vox.saz.exception.FindRoleUnexpectedException;
import gov.fnal.vox.saz.exception.ListRolesException;

public interface RoleDao extends BaseDao{
	public void add(Session session,String dn,String enabled,String trusted) throws AddRoleException;
	public Role find(Session session,String dn) throws FindRoleException, FindRoleUnexpectedException;
	public List<Role> list(Session session) throws ListRolesException;
	public List<Role> listAllBannedRoles(Session session) throws ListRolesException;
	public List<Role> listAllUnbannedRoles(Session session) throws ListRolesException;
	public List<Role> listAllTrustedRoles(Session session) throws ListRolesException;
	public List<Role> listAllDistrustedRoles(Session session) throws ListRolesException;
	public void banRoleBasedOnDN(Session session,String dn) throws BanRoleException;
	public void unbanRoleBasedOnDN(Session session,String dn) throws UnbanRoleException;
	public void trustRoleBasedOnDN(Session session,String dn) throws TrustRoleException;
	public void distrustRoleBasedOnDN(Session session,String dn) throws DistrustRoleException;
}

