/*****************************************************************************
*       File            UserDao.java
*       Author          Neha Sharma
*       Date            August 26' 2009
*       Organization    Fermi National Accelerator Laboratory
*       Description     The DAO interface for User entity.
*       Email           neha@fnal.gov
******************************************************************************/
package gov.fnal.vox.saz.dao;

import java.util.List;
import org.hibernate.Session;
import gov.fnal.vox.saz.entity.User;
import gov.fnal.vox.saz.exception.AddUserException;
import gov.fnal.vox.saz.exception.BanUserException;
import gov.fnal.vox.saz.exception.UnbanUserException;
import gov.fnal.vox.saz.exception.TrustUserException;
import gov.fnal.vox.saz.exception.DistrustUserException;
import gov.fnal.vox.saz.exception.FindUserException;
import gov.fnal.vox.saz.exception.FindUserUnexpectedException;
import gov.fnal.vox.saz.exception.ListUsersException;

public interface UserDao extends BaseDao{
	public void add(Session session,String dn,String enabled,String trusted) throws AddUserException;
	public User find(Session session,String dn) throws FindUserException, FindUserUnexpectedException;
	public List<User> list(Session session) throws ListUsersException;
	public List<User> listAllBannedUsers(Session session) throws ListUsersException;
	public List<User> listAllUnbannedUsers(Session session) throws ListUsersException;
	public List<User> listAllTrustedUsers(Session session) throws ListUsersException;
	public List<User> listAllDistrustedUsers(Session session) throws ListUsersException;
	public void banUserBasedOnDN(Session session,String dn) throws BanUserException;
	public void unbanUserBasedOnDN(Session session,String dn) throws UnbanUserException;
	public void trustUserBasedOnDN(Session session,String dn) throws TrustUserException;
	public void distrustUserBasedOnDN(Session session,String dn) throws DistrustUserException;
}

