/*****************************************************************************
*       File            VODao.java
*       Author          Neha Sharma
*       Date            August 26' 2009
*       Organization    Fermi National Accelerator Laboratory
*       Description     The DAO interface for VO entity.
*       Email           neha@fnal.gov
******************************************************************************/
package gov.fnal.vox.saz.dao;

import java.util.List;
import org.hibernate.Session;
import gov.fnal.vox.saz.entity.VO;
import gov.fnal.vox.saz.exception.AddVOException;
import gov.fnal.vox.saz.exception.FindVOException;
import gov.fnal.vox.saz.exception.BanVOException;
import gov.fnal.vox.saz.exception.UnbanVOException;
import gov.fnal.vox.saz.exception.TrustVOException;
import gov.fnal.vox.saz.exception.DistrustVOException;
import gov.fnal.vox.saz.exception.FindVOUnexpectedException;
import gov.fnal.vox.saz.exception.ListVOsException;

public interface VODao extends BaseDao{
	public void add(Session session,String dn,String enabled,String trusted) throws AddVOException;
	public VO find(Session session,String dn) throws FindVOException, FindVOUnexpectedException;
	public List<VO> list(Session session) throws ListVOsException;
	public List<VO> listAllBannedVOs(Session session) throws ListVOsException;
	public List<VO> listAllUnbannedVOs(Session session) throws ListVOsException;
	public List<VO> listAllTrustedVOs(Session session) throws ListVOsException;
	public List<VO> listAllDistrustedVOs(Session session) throws ListVOsException;
	public void banVOBasedOnDN(Session session,String dn) throws BanVOException;
	public void unbanVOBasedOnDN(Session session,String dn) throws UnbanVOException;
	public void trustVOBasedOnDN(Session session,String dn) throws TrustVOException;
	public void distrustVOBasedOnDN(Session session,String dn) throws DistrustVOException;
}

